## opentoonz-dmo 1.7.1.1

=== plugins/blur/CMakeLists.txt ===
project(blur_plugin C CXX)
set(PLUGINSDK_ROOT ../../toonz/sources/toonzqt)
set(PLUGINSDK_UTILS_PATH ../)

set(HEADERS
    ${PLUGINSDK_ROOT}/toonz_plugin.h
    ${PLUGINSDK_ROOT}/toonz_hostif.h
)

set(SOURCES
    blur.cpp
)

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -stdlib=libc++")
endif()

add_library(blur SHARED ${HEADERS} ${SOURCES})

set_target_properties(blur PROPERTIES
    PREFIX ""
    SUFFIX ".plugin"
)

include_directories(${PLUGINSDK_ROOT} ${PLUGINSDK_UTILS_PATH})

=== plugins/geom/CMakeLists.txt ===
project(geom_plugin)

set(PLUGINSDK_ROOT ../../toonz/sources/toonzqt)
set(PLUGINSDK_UTILS_PATH ../)

set(HEADERS
    ${PLUGINSDK_ROOT}/toonz_plugin.h
    ${PLUGINSDK_ROOT}/toonz_hostif.h
)

set(SOURCES
    geom.cpp
)

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -stdlib=libc++")
endif()

add_library(geom SHARED ${HEADERS} ${SOURCES})

set_target_properties(geom PROPERTIES
    PREFIX ""
    SUFFIX ".plugin"
)

include_directories(${PLUGINSDK_ROOT} ${PLUGINSDK_UTILS_PATH})

=== plugins/multiplugin/CMakeLists.txt ===
project(multi_plugin)
set(PLUGINSDK_ROOT ../../toonz/sources/toonzqt)
set(PLUGINSDK_UTILS_PATH ../)

set(HEADERS
    ${PLUGINSDK_ROOT}/toonz_plugin.h
    ${PLUGINSDK_ROOT}/toonz_hostif.h
)

set(SOURCES
    multi.cpp
)

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -stdlib=libc++")
endif()

add_library(multi SHARED ${HEADERS} ${SOURCES})

set_target_properties(multi PROPERTIES
    PREFIX ""
    SUFFIX ".plugin"
)

include_directories(${PLUGINSDK_ROOT} ${PLUGINSDK_UTILS_PATH})

=== toonz/sources/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

set(CMAKE_BUILD_TYPE_INIT Release)

project(OpenToonz)

# Set C++17 globally 
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "C++ standard: ${CMAKE_CXX_STANDARD}")

#-----------------------------------------------------------------------------
# Platform Specific Defaults

# list of var-names
set(_init_vars)

#-----------------------------------------------------------------------------
# Select build target
set(BUILD_TARGET_WIN       OFF)
set(BUILD_TARGET_APPLE     OFF)
set(BUILD_TARGET_UNIX      OFF)
if(WIN32)
    set(BUILD_TARGET_WIN    ON)
    message(STATUS "Target system is WIN")
elseif(APPLE)
    set(BUILD_TARGET_APPLE  ON)
    message(STATUS "Target system is APPLE")
elseif(UNIX)
    set(BUILD_TARGET_UNIX   ON)
    message(STATUS "Target system is UNIX")
else()
    set(BUILD_TARGET_UNIX   ON)
    message(WARNING "Target system unknown, set UNIX by default")
    message(STATUS "Target system is UNIX (actually unknown)")
endif()

#-----------------------------------------------------------------------------
# Select build environment

set(BUILD_ENV_MSVC     OFF)
set(BUILD_ENV_APPLE    OFF)
set(BUILD_ENV_UNIXLIKE OFF)
if(MSVC)
    set(BUILD_ENV_MSVC ON)
    if(NOT BUILD_TARGET_WIN)
        message(WARNING "Build environment is MSVC, but target system is not WIN")
    endif()
    message(STATUS "Build environment is MSVC")
elseif(CMAKE_HOST_APPLE)
    set(BUILD_ENV_APPLE ON)
    if(NOT BUILD_TARGET_APPLE)
        message(WARNING "Build environment is APPLE, but target system is not APPLE")
    endif()
    message(STATUS "Build environment is APPLE")
elseif(CMAKE_HOST_UNIX OR CMAKE_COMPILER_IS_GNUCC)
    set(BUILD_ENV_UNIXLIKE ON)
    if(NOT BUILD_TARGET_UNIX AND NOT BUILD_TARGET_WIN)
        message(WARNING "Build environment is UNIXLIKE, but target system is not UNIX or WIN")
    endif()
    message(STATUS "Build environment is UNIXLIKE")
else()
    message(ERROR "Unsupported build environment, only MSVC, APPLE and UNIXLIKE are supported")
endif()


# initialize to ON
macro(option_defaults_init)
    foreach(_var ${ARGV})
        set(${_var} ON)
        list(APPEND _init_vars "${_var}")
    endforeach()
    unset(_var)
endmacro()

# remove from namespace
macro(option_defaults_clear)
    foreach(_var ${_init_vars})
        unset(${_var})
    endforeach()
    unset(_var)
    unset(_init_vars)
endmacro()

# values to initialize WITH_****
option_defaults_init(
    _init_SYSTEM_LZO
)

# customize...
if(BUILD_ENV_MSVC)
    set(_init_SYSTEM_LZO                     OFF)
    set(_init_SYSTEM_SUPERLU                 OFF)
elseif(BUILD_ENV_APPLE)
    set(_init_SYSTEM_LZO                     OFF)
    set(_init_SYSTEM_SUPERLU                 OFF)
elseif(BUILD_ENV_UNIXLIKE)
    set(_init_SYSTEM_LZO                     ON)
    set(_init_SYSTEM_SUPERLU                 ON)
endif()


#-----------------------------------------------------------------------------
# Build Options

option(WITH_SYSTEM_LZO "Use the system LZO library instead of 'thirdpary'" ${_init_SYSTEM_LZO})
option(WITH_SYSTEM_SUPERLU "Use the system SuperLU library instead of 'thirdpary'" ${_init_SYSTEM_SUPERLU})
option(WITH_CANON "Build with Canon DSLR support - Requires Canon SDK" OFF)
option(WITH_TRANSLATION "Generate translation projects as well" ON)
option(WITH_WINTAB "(Windows only) Build with customized Qt with WinTab support. https://github.com/shun-iwasawa/qt5/releases/tag/v5.15.2_wintab" OFF)

# avoid using again
option_defaults_clear()

# end option(...)

#-----------------------------------------------------------------------------
# Platform Architecture

if(BUILD_ENV_APPLE)
    if(NOT PLATFORM)
        set(PLATFORM 64)
    endif()
else() # Windows and Linux case
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(PLATFORM 64)
        set(PLATFORM2 _64)
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(PLATFORM 32)
        set(PLATFORM2)
    else()
        message("Warning : CMAKE_SIZEOF_VOID_P = ${CMAKE_SIZEOF_VOID_P}")
        set(PLATFORM 64)
        set(PLATFORM2 _64)
    endif()
endif()
message("PLATFORM:" ${PLATFORM})

#-----------------------------------------------------------------------------
# Third Party & System Libs

include(${CMAKE_SOURCE_DIR}/../cmake/util_compiler.cmake)

get_filename_component(SDKROOT ../../thirdparty/ ABSOLUTE)
message(STATUS "SDK Root:" ${SDKROOT})
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/../cmake")
if(BUILD_ENV_APPLE)
    set(THIRDPARTY_LIBS_HINTS "/usr/local/Cellar/" "/opt/include" ${SDKROOT})
elseif(BUILD_ENV_MSVC OR BUILD_ENV_UNIXLIKE)
    set(THIRDPARTY_LIBS_HINTS ${SDKROOT})
endif()

if(BUILD_ENV_MSVC)
    # configure the third party libs (only once) to avoid manual copies
    message(STATUS "configure the third party libs")
    if(NOT EXISTS"${SDKROOT}/libpng-1.6.21")
        file(COPY "${SDKROOT}/libpng-1.6.21/scripts/pnglibconf.h.prebuilt" DESTINATION "${SDKROOT}/libpng-1.6.21")
        file(RENAME "${SDKROOT}/libpng-1.6.21/pnglibconf.h.prebuilt" "${SDKROOT}/libpng-1.6.21/pnglibconf.h")
    endif()
    if(NOT EXISTS "${SDKROOT}/tiff-4.0.3/libtiff/tif_config.h")
        file(COPY_FILE "${SDKROOT}/tiff-4.0.3/libtiff/tif_config.vc.h" "${SDKROOT}/tiff-4.0.3/libtiff/tif_config.h")
    endif()
    if(NOT EXISTS "${SDKROOT}/tiff-4.0.3/libtiff/tiffconf.h")
        file(COPY_FILE "${SDKROOT}/tiff-4.0.3/libtiff/tiffconf.vc.h" "${SDKROOT}/tiff-4.0.3/libtiff/tiffconf.h")
    endif()
endif()

message(STATUS "Thirdpary Library Search path:" ${THIRDPARTY_LIBS_HINTS})

if(BUILD_ENV_MSVC)
    set(QT_PATH "C:/Qt/5.15.2/msvc2019${PLATFORM2}" CACHE PATH "Qt installation directory")
    if(NOT EXISTS ${QT_PATH})
        message("Specify QT_PATH properly")
        return()
    endif()
    set(QT_LIB_PATH ${QT_PATH})
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${QT_PATH}/lib/cmake/")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /std:c++17 /wd4251")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /std:c++17 /wd4251")
    add_definitions(
        -DVC_EXTRALEAN
        -DNOMINMAX
        -D_USE_MATH_DEFINES
    )
elseif(BUILD_ENV_APPLE)
    set(QT_PATH "~/Qt5.9.2/5.9.2/clang_${PLATFORM}/lib" CACHE PATH "Qt installation directory")
    set(QT_LIB_PATH "${QT_PATH}/")
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${QT_LIB_PATH}cmake/")
    foreach(path ${CMAKE_PREFIX_PATH})
        message("CMAKE_PREFIX_PATH: " ${path})
    endforeach(path)
    add_definitions(
        -DMACOSX
        -Di386
        -D__MACOS__
    )
    if(PLATFORM EQUAL 64)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64 -std=c++17 -stdlib=libc++ -fno-implicit-templates")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m64")
    elseif(PLATFORM EQUAL 32)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32 -std=c++17 -stdlib=libc++ -fno-implicit-templates -D HAS_QUICKDRAW")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
        set(CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -m32")
    else()
        message(FATAL_ERROR "Invalid PLATFORM:" ${PLATFORM} ". 'PLATFORM' must be 32 or 64.")
    endif()
elseif(BUILD_ENV_UNIXLIKE)
    # Needed for correct Qt detection
    cmake_minimum_required(VERSION 2.8.12)
    set(PRELOAD_VARIABLE "LD_LIBRARY_PATH")
    if(CMAKE_SYSTEM_NAME MATCHES "Linux")
        add_definitions(-DLINUX)
    elseif(CMAKE_SYSTEM_NAME MATCHES "Haiku")
        add_definitions(-DHAIKU)
        set(PRELOAD_VARIABLE "LIBRARY_PATH")
    elseif(CMAKE_SYSTEM_NAME MATCHES "^.*BSD$|DragonFly")
        set(BUILD_TARGET_BSD ON)
        add_definitions(-D_BSD_SOURCE -DFREEBSD)
        include_directories("/usr/local/include/")
        message(STATUS "Configuring for BSD system")
    elseif(NOT BUILD_TARGET_WIN)
        message(WARNING "Support for generic Unix (Not Apple or Linux) isn't yet working!")
    endif()

    set(CMAKE_CXX_STANDARD 17)

    find_package(Qt5Widgets)

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
    if (NOT (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -lstdc++")
    endif()
endif()

add_definitions(
    -DQT_GUI_LIB
    -DQT_NETWORK_LIB
    -DQT_CORE_LIB
    -DQT_SHARED
)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

if(BUILD_ENV_APPLE)
    set(CMAKE_MACOSX_RPATH ON)
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH ${QT_LIB_PATH})
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    set(CMAKE_FIND_FRAMEWORK LAST)
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${QT_LIB_PATH}" isSystemDir)
    if("${isSystemDir}" STREQUAL "-1")
        set(CMAKE_INSTALL_RPATH "${QT_LIB_PATH}")
    endif()
endif()

include_directories(
    include
)

# Find the QtWidgets library
find_package(Qt5 REQUIRED
    Core
    Gui
    Network
    OpenGL
    Svg
    Xml
    Script
    Widgets
    PrintSupport
    LinguistTools
    Multimedia
    MultimediaWidgets
    SerialPort
    UiTools
)

set(QT_MINIMUM_VERSION 5.5.0)
if(Qt5Core_VERSION VERSION_LESS QT_MINIMUM_VERSION)
    MESSAGE(FATAL_ERROR "Minimum supported Qt version: ${QT_MINIMUM_VERSION}.
    Installed version: ${Qt5Core_VERSION}")
endif()
unset(QT_MINIMUM_VERSION)

if(BUILD_ENV_MSVC)
    include_directories(
        SYSTEM
        ${SDKROOT}/glut/3.7.6/include
        ${SDKROOT}/zlib-1.2.8
        #${SDKROOT}/LibJPEG/jpeg-9
        ${SDKROOT}/libjpeg-turbo/include
    )
    add_definitions(
        -DGLUT_NO_LIB_PRAGMA
    )
endif()


if(PLATFORM EQUAL 64)
    if(BUILD_ENV_UNIXLIKE)
        find_package(OpenCV REQUIRED)
    else() # Windows and MacOS case
        find_package(OpenCV 4.1 REQUIRED)
    endif()
    #include_directories(
    #    ${SDKROOT}/libjpeg-turbo64/include
    #)
    if(WITH_CANON)
        include_directories(
            ${SDKROOT}/canon/Header
        )
    endif()
endif()

get_target_property(QtCore_location Qt5::Core LOCATION)
get_target_property(QtWidget_location Qt5::Widgets LOCATION)
message(STATUS "Qt Core Location:" ${QtCore_location})

macro(_find_toonz_library OUT_LIB_LIST IN_LIB_LIST)
    set(OUTLIST "")
    foreach(arg ${IN_LIB_LIST})
        unset(COREPATH CACHE)
        # find しても cmake が走るときにはできていないので完全なパス名を生成して返すだけ
        if(BUILD_ENV_APPLE)
            set(LIBPATH "\$<TARGET_FILE:${arg}>")
        else()
            set(LIBPATH ${arg})
        endif()
        set(OUTLIST ${OUTLIST} ${LIBPATH})
    endforeach()
    set(${OUT_LIB_LIST} ${OUTLIST})
endmacro()

set(TNZSTDFX_Location)
set(TFARM_Location)

set(QT_LIB)  # avoid warning

if(BUILD_ENV_MSVC)
    set(MSVC_LIB_VERSION 2015)

    set(GLUT_LIB ${SDKROOT}/glut/3.7.6/lib/glut${PLATFORM}.lib)
    set(GL_LIB opengl32.lib)
    set(Z_LIB
        optimized ${SDKROOT}/zlib-1.2.8/lib/zlib-1.2.8_${MSVC_LIB_VERSION}${PLATFORM2}.lib
        debug ${SDKROOT}/zlib-1.2.8/lib/zlib-1.2.8_${MSVC_LIB_VERSION}${PLATFORM2}d.lib
    )
    #set(JPEG_LIB ${SDKROOT}/LibJPEG/jpeg-9/lib/LibJPEG-9_${MSVC_LIB_VERSION}${PLATFORM2}.lib)
    set(JPEG_LIB ${SDKROOT}/libjpeg-turbo/lib/jpeg-static_${MSVC_LIB_VERSION}${PLATFORM2}.lib)
    set(TURBOJPEG_LIB ${SDKROOT}/libjpeg-turbo/lib/turbojpeg-static_${MSVC_LIB_VERSION}${PLATFORM2}.lib)
    set(TIFF_INCLUDE_DIR ${SDKROOT}/tiff-4.0.3/libtiff)
    set(TIFF_LIB
        optimized ${SDKROOT}/tiff-4.0.3/lib/LibTIFF-4.0.3_${MSVC_LIB_VERSION}${PLATFORM2}.lib
        debug  ${SDKROOT}/tiff-4.0.3/lib/LibTIFF-4.0.3_${MSVC_LIB_VERSION}${PLATFORM2}d.lib
    )
    set(PNG_LIB
        optimized ${SDKROOT}/libpng-1.6.21/lib/libpng16_${MSVC_LIB_VERSION}${PLATFORM2}.lib
        debug  ${SDKROOT}/libpng-1.6.21/lib/libpng16_${MSVC_LIB_VERSION}${PLATFORM2}d.lib
    )
    set(GLEW_LIB ${SDKROOT}/glew/glew-1.9.0/lib/glew${PLATFORM}.lib)
    set(LZ4_LIB ${SDKROOT}/Lz4/Lz4_131/lz4_${PLATFORM}.lib)
    set(SUPERLU_LIB ${SDKROOT}/superlu/SuperLU_${MSVC_LIB_VERSION}_${PLATFORM}.lib)
    set(OPENBLAS_LIB ${SDKROOT}/openblas/libopenblas_${PLATFORM}.lib)
    set(USB_LIB)  # unused

    if(PLATFORM EQUAL 32)

=== thirdparty/libjpeg-turbo/libjpeg-turbo-2.0.6/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

if(CMAKE_EXECUTABLE_SUFFIX)
  set(CMAKE_EXECUTABLE_SUFFIX_TMP ${CMAKE_EXECUTABLE_SUFFIX})
endif()

project(libjpeg-turbo C)
set(VERSION 2.0.6)
string(REPLACE "." ";" VERSION_TRIPLET ${VERSION})
list(GET VERSION_TRIPLET 0 VERSION_MAJOR)
list(GET VERSION_TRIPLET 1 VERSION_MINOR)
list(GET VERSION_TRIPLET 2 VERSION_REVISION)
function(pad_number NUMBER OUTPUT_LEN)
  string(LENGTH "${${NUMBER}}" INPUT_LEN)
  if(INPUT_LEN LESS OUTPUT_LEN)
    math(EXPR ZEROES "${OUTPUT_LEN} - ${INPUT_LEN} - 1")
    set(NUM ${${NUMBER}})
    foreach(C RANGE ${ZEROES})
      set(NUM "0${NUM}")
    endforeach()
    set(${NUMBER} ${NUM} PARENT_SCOPE)
  endif()
endfunction()
pad_number(VERSION_MINOR 3)
pad_number(VERSION_REVISION 3)
set(LIBJPEG_TURBO_VERSION_NUMBER ${VERSION_MAJOR}${VERSION_MINOR}${VERSION_REVISION})

string(TIMESTAMP DEFAULT_BUILD "%Y%m%d")
set(BUILD ${DEFAULT_BUILD} CACHE STRING "Build string (default: ${DEFAULT_BUILD})")

# NOTE: On Windows, this does nothing except when using MinGW or Cygwin.
# CMAKE_BUILD_TYPE has no meaning in Visual Studio, and it always defaults to
# Debug when using NMake.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()
message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")

message(STATUS "VERSION = ${VERSION}, BUILD = ${BUILD}")

# Detect CPU type and whether we're building 64-bit or 32-bit code
math(EXPR BITS "${CMAKE_SIZEOF_VOID_P} * 8")
string(TOLOWER ${CMAKE_SYSTEM_PROCESSOR} CMAKE_SYSTEM_PROCESSOR_LC)
if(CMAKE_SYSTEM_PROCESSOR_LC MATCHES "x86_64" OR
  CMAKE_SYSTEM_PROCESSOR_LC MATCHES "amd64" OR
  CMAKE_SYSTEM_PROCESSOR_LC MATCHES "i[0-9]86" OR
  CMAKE_SYSTEM_PROCESSOR_LC MATCHES "x86" OR
  CMAKE_SYSTEM_PROCESSOR_LC MATCHES "ia32")
  if(BITS EQUAL 64)
    set(CPU_TYPE x86_64)
  else()
    set(CPU_TYPE i386)
  endif()
  if(NOT CMAKE_SYSTEM_PROCESSOR STREQUAL ${CPU_TYPE})
    set(CMAKE_SYSTEM_PROCESSOR ${CPU_TYPE})
  endif()
elseif(CMAKE_SYSTEM_PROCESSOR_LC STREQUAL "aarch64" OR
  CMAKE_SYSTEM_PROCESSOR_LC MATCHES "arm*")
  if(BITS EQUAL 64)
    set(CPU_TYPE arm64)
  else()
    set(CPU_TYPE arm)
  endif()
elseif(CMAKE_SYSTEM_PROCESSOR_LC MATCHES "ppc*" OR
  CMAKE_SYSTEM_PROCESSOR_LC MATCHES "powerpc*")
  set(CPU_TYPE powerpc)
else()
  set(CPU_TYPE ${CMAKE_SYSTEM_PROCESSOR_LC})
endif()
message(STATUS "${BITS}-bit build (${CPU_TYPE})")


###############################################################################
# INSTALL DIRECTORIES
###############################################################################

if(WIN32)
  if(MSVC)
    set(CMAKE_INSTALL_DEFAULT_PREFIX "c:/${CMAKE_PROJECT_NAME}")
  else()
    set(CMAKE_INSTALL_DEFAULT_PREFIX "c:/${CMAKE_PROJECT_NAME}-gcc")
  endif()
  if(BITS EQUAL 64)
    set(CMAKE_INSTALL_DEFAULT_PREFIX "${CMAKE_INSTALL_DEFAULT_PREFIX}64")
  endif()
else()
  set(CMAKE_INSTALL_DEFAULT_PREFIX /opt/${CMAKE_PROJECT_NAME})
endif()
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_DEFAULT_PREFIX}" CACHE PATH
    "Directory into which to install ${CMAKE_PROJECT_NAME} (default: ${CMAKE_INSTALL_DEFAULT_PREFIX})"
    FORCE)
endif()
message(STATUS "CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")

# When the prefix is /opt/${CMAKE_PROJECT_NAME}, we assume that an "official"
# build is being created, and thus we install things into specific locations.

if(CMAKE_INSTALL_PREFIX STREQUAL "${CMAKE_INSTALL_DEFAULT_PREFIX}")
  set(CMAKE_INSTALL_DEFAULT_DATAROOTDIR "")
  set(CMAKE_INSTALL_DEFAULT_DOCDIR "<CMAKE_INSTALL_DATAROOTDIR>/doc")
  set(CMAKE_INSTALL_DEFAULT_JAVADIR "<CMAKE_INSTALL_DATAROOTDIR>/classes")
  if(UNIX AND NOT APPLE)
    if(BITS EQUAL 64)
      set(CMAKE_INSTALL_DEFAULT_LIBDIR "lib64")
    else()
      set(CMAKE_INSTALL_DEFAULT_LIBDIR "lib32")
    endif()
  endif()
endif()

include(cmakescripts/GNUInstallDirs.cmake)

macro(report_directory var)
  if(CMAKE_INSTALL_${var} STREQUAL CMAKE_INSTALL_FULL_${var})
    message(STATUS "CMAKE_INSTALL_${var} = ${CMAKE_INSTALL_${var}}")
  else()
    message(STATUS "CMAKE_INSTALL_${var} = ${CMAKE_INSTALL_${var}} (${CMAKE_INSTALL_FULL_${var}})")
  endif()
  mark_as_advanced(CLEAR CMAKE_INSTALL_${var})
endmacro()

set(DIRLIST "BINDIR;DATAROOTDIR;DOCDIR;INCLUDEDIR;LIBDIR")
if(UNIX)
  list(APPEND DIRLIST "MANDIR")
endif()
foreach(dir ${DIRLIST})
  report_directory(${dir})
endforeach()


###############################################################################
# CONFIGURATION OPTIONS
###############################################################################

macro(boolean_number var)
  if(${var})
    set(${var} 1)
  else()
    set(${var} 0)
  endif()
endmacro()

option(ENABLE_SHARED "Build shared libraries" TRUE)
boolean_number(ENABLE_SHARED)
option(ENABLE_STATIC "Build static libraries" TRUE)
boolean_number(ENABLE_STATIC)
option(REQUIRE_SIMD "Generate a fatal error if SIMD extensions are not available for this platform (default is to fall back to a non-SIMD build)" FALSE)
boolean_number(REQUIRE_SIMD)
option(WITH_12BIT "Encode/decode JPEG images with 12-bit samples (implies WITH_ARITH_DEC=0 WITH_ARITH_ENC=0 WITH_JAVA=0 WITH_SIMD=0 WITH_TURBOJPEG=0 )" FALSE)
boolean_number(WITH_12BIT)
option(WITH_ARITH_DEC "Include arithmetic decoding support when emulating the libjpeg v6b API/ABI" TRUE)
boolean_number(WITH_ARITH_DEC)
option(WITH_ARITH_ENC "Include arithmetic encoding support when emulating the libjpeg v6b API/ABI" TRUE)
boolean_number(WITH_ARITH_ENC)
option(WITH_JAVA "Build Java wrapper for the TurboJPEG API library (implies ENABLE_SHARED=1)" FALSE)
boolean_number(WITH_JAVA)
option(WITH_JPEG7 "Emulate libjpeg v7 API/ABI (this makes ${CMAKE_PROJECT_NAME} backward-incompatible with libjpeg v6b)" FALSE)
boolean_number(WITH_JPEG7)
option(WITH_JPEG8 "Emulate libjpeg v8 API/ABI (this makes ${CMAKE_PROJECT_NAME} backward-incompatible with libjpeg v6b)" FALSE)
boolean_number(WITH_JPEG8)
option(WITH_MEM_SRCDST "Include in-memory source/destination manager functions when emulating the libjpeg v6b or v7 API/ABI" TRUE)
boolean_number(WITH_MEM_SRCDST)
option(WITH_SIMD "Include SIMD extensions, if available for this platform" TRUE)
boolean_number(WITH_SIMD)
option(WITH_TURBOJPEG "Include the TurboJPEG API library and associated test programs" TRUE)
boolean_number(WITH_TURBOJPEG)

macro(report_option var desc)
  if(${var})
    message(STATUS "${desc} enabled (${var} = ${${var}})")
  else()
    message(STATUS "${desc} disabled (${var} = ${${var}})")
  endif()
endmacro()

if(WITH_JAVA)
  set(ENABLE_SHARED 1)
endif()

# Explicitly setting CMAKE_POSITION_INDEPENDENT_CODE=FALSE disables PIC for all
# targets, which will cause the shared library builds to fail.  Thus, if shared
# libraries are enabled and CMAKE_POSITION_INDEPENDENT_CODE is explicitly set
# to FALSE, we need to unset it, thus restoring the default behavior
# (automatically using PIC for shared library targets.)
if(DEFINED CMAKE_POSITION_INDEPENDENT_CODE AND
  NOT CMAKE_POSITION_INDEPENDENT_CODE AND ENABLE_SHARED)
  unset(CMAKE_POSITION_INDEPENDENT_CODE CACHE)
endif()

report_option(ENABLE_SHARED "Shared libraries")
report_option(ENABLE_STATIC "Static libraries")

if(ENABLE_SHARED)
  set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
endif()

if(WITH_JPEG8 OR WITH_JPEG7)
  set(WITH_ARITH_ENC 1)
  set(WITH_ARITH_DEC 1)
endif()
if(WITH_JPEG8)
  set(WITH_MEM_SRCDST 0)
endif()

if(WITH_12BIT)
  set(WITH_ARITH_DEC 0)
  set(WITH_ARITH_ENC 0)
  set(WITH_JAVA 0)
  set(WITH_SIMD 0)
  set(WITH_TURBOJPEG 0)
  set(BITS_IN_JSAMPLE 12)
else()
  set(BITS_IN_JSAMPLE 8)
endif()
report_option(WITH_12BIT "12-bit JPEG support")

if(WITH_ARITH_DEC)
  set(D_ARITH_CODING_SUPPORTED 1)
endif()
if(NOT WITH_12BIT)
  report_option(WITH_ARITH_DEC "Arithmetic decoding support")
endif()

if(WITH_ARITH_ENC)
  set(C_ARITH_CODING_SUPPORTED 1)
endif()
if(NOT WITH_12BIT)
  report_option(WITH_ARITH_ENC "Arithmetic encoding support")
endif()

if(NOT WITH_12BIT)
  report_option(WITH_TURBOJPEG "TurboJPEG API library")
  report_option(WITH_JAVA "TurboJPEG Java wrapper")
endif()

if(WITH_MEM_SRCDST)
  set(MEM_SRCDST_SUPPORTED 1)
  set(MEM_SRCDST_FUNCTIONS "global:  jpeg_mem_dest;  jpeg_mem_src;")
endif()
if(NOT WITH_JPEG8)
  report_option(WITH_MEM_SRCDST "In-memory source/destination managers")
endif()

set(SO_AGE 2)
if(WITH_MEM_SRCDST)
  set(SO_AGE 3)
endif()

if(WITH_JPEG8)
  set(JPEG_LIB_VERSION 80)
elseif(WITH_JPEG7)
  set(JPEG_LIB_VERSION 70)
else()
  set(JPEG_LIB_VERSION 62)
endif()

math(EXPR JPEG_LIB_VERSION_DIV10 "${JPEG_LIB_VERSION} / 10")
math(EXPR JPEG_LIB_VERSION_MOD10 "${JPEG_LIB_VERSION} % 10")
if(JPEG_LIB_VERSION STREQUAL "62")
  set(DEFAULT_SO_MAJOR_VERSION ${JPEG_LIB_VERSION})
else()
  set(DEFAULT_SO_MAJOR_VERSION ${JPEG_LIB_VERSION_DIV10})
endif()
if(JPEG_LIB_VERSION STREQUAL "80")
  set(DEFAULT_SO_MINOR_VERSION 2)
else()
  set(DEFAULT_SO_MINOR_VERSION 0)
endif()

# This causes SO_MAJOR_VERSION/SO_MINOR_VERSION to reset to defaults if
# WITH_JPEG7 or WITH_JPEG8 has changed.
if((DEFINED WITH_JPEG7_INT AND NOT WITH_JPEG7 EQUAL WITH_JPEG7_INT) OR
  (DEFINED WITH_JPEG8_INT AND NOT WITH_JPEG8 EQUAL WITH_JPEG8_INT))
  set(FORCE_SO_VERSION "FORCE")
endif()
set(WITH_JPEG7_INT ${WITH_JPEG7} CACHE INTERNAL "")
set(WITH_JPEG8_INT ${WITH_JPEG8} CACHE INTERNAL "")

set(SO_MAJOR_VERSION ${DEFAULT_SO_MAJOR_VERSION} CACHE STRING
  "Major version of the libjpeg API shared library (default: ${DEFAULT_SO_MAJOR_VERSION})"
  ${FORCE_SO_VERSION})
set(SO_MINOR_VERSION ${DEFAULT_SO_MINOR_VERSION} CACHE STRING
  "Minor version of the libjpeg API shared library (default: ${DEFAULT_SO_MINOR_VERSION})"
  ${FORCE_SO_VERSION})

set(JPEG_LIB_VERSION_DECIMAL "${JPEG_LIB_VERSION_DIV10}.${JPEG_LIB_VERSION_MOD10}")
message(STATUS "Emulating libjpeg API/ABI v${JPEG_LIB_VERSION_DECIMAL} (WITH_JPEG7 = ${WITH_JPEG7}, WITH_JPEG8 = ${WITH_JPEG8})")
message(STATUS "libjpeg API shared library version = ${SO_MAJOR_VERSION}.${SO_AGE}.${SO_MINOR_VERSION}")

# Because the TurboJPEG API library uses versioned symbols and changes the
# names of functions whenever they are modified in a backward-incompatible
# manner, it is always backward-ABI-compatible with itself, so the major and
# minor SO versions don't change.  However, we increase the middle number (the
# SO "age") whenever functions are added to the API.
set(TURBOJPEG_SO_MAJOR_VERSION 0)
set(TURBOJPEG_SO_VERSION 0.2.0)


###############################################################################
# COMPILER SETTINGS
###############################################################################

if(MSVC)
  option(WITH_CRT_DLL
    "Link all ${CMAKE_PROJECT_NAME} libraries and executables with the C run-time DLL (msvcr*.dll) instead of the static C run-time library (libcmt*.lib.)  The default is to use the C run-time DLL only with the libraries and executables that need it."
    FALSE)
  if(NOT WITH_CRT_DLL)
    # Use the static C library for all build types
    foreach(var CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
      CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${var} "${${var}}")
      endif()
    endforeach()
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /W3 /wd4996")
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
  # Use the maximum optimization level for release builds
  foreach(var CMAKE_C_FLAGS_RELEASE CMAKE_C_FLAGS_RELWITHDEBINFO)
    if(${var} MATCHES "-O2")
      string(REGEX REPLACE "-O2" "-O3" ${var} "${${var}}")
    endif()
  endforeach()
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  if(CMAKE_C_COMPILER_ID MATCHES "SunPro")
    # Use the maximum optimization level for release builds
    foreach(var CMAKE_C_FLAGS_RELEASE CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${var} MATCHES "-xO3")
        string(REGEX REPLACE "-xO3" "-xO5" ${var} "${${var}}")
      endif()
      if(${var} MATCHES "-xO2")
        string(REGEX REPLACE "-xO2" "-xO5" ${var} "${${var}}")
      endif()
    endforeach()
  endif()

=== thirdparty/lzo/driver/CMakeLists.txt ===
project(lzotools)

if(MSVC)
	# use pre-built 2.03
	get_filename_component(LZO_PATH ${SDKROOT}/lzo/2.03 ABSOLUTE)
	link_directories(${LZO_PATH}/LZO_lib/)
	if (CMAKE_SIZEOF_VOID_P EQUAL 8) 
		set(PREFIX _64)
	endif (CMAKE_SIZEOF_VOID_P EQUAL 8)
else()
    set(LZO_PATH ${LZO_INCLUDE_DIR})
endif()

include_directories(${LZO_PATH} ${LZO_PATH}/include)
add_definitions(-DLZO_USE_ASM)
add_executable(lzocompress  lzocompress.c)
add_executable(lzodecompress lzodecompress.c)
if(MSVC)
	target_link_libraries(lzocompress lzo2${PREFIX} ${LZO_LIBRARY})
	target_link_libraries(lzodecompress lzo2${PREFIX} ${LZO_LIBRARY})
else()
	target_link_libraries(lzocompress ${LZO_LIBRARY})
	target_link_libraries(lzodecompress ${LZO_LIBRARY})
endif()
set(LZODRIVER_FOUND true PARENT_SCOPE)

=== toonz/sources/colorfx/CMakeLists.txt ===
set(HEADERS
    ../include/colorfx.h
    colorfxutils.h
    rasterstyles.h
    regionstyles.h
    strokestyles.h
    zigzagstyles.h
    flowlinestrokestyle.h
)

set(SOURCES
    colorfx.cpp
    colorfxutils.cpp
    rasterstyles.cpp
    regionstyles.cpp
    strokestyles.cpp
    zigzagstyles.cpp
    flowlinestrokestyle.cpp
)

if(WITH_TRANSLATION)
    add_translation(colorfx ${HEADERS} ${SOURCES})
endif()

add_library(colorfx SHARED ${HEADERS} ${SOURCES})
add_definitions(
    -D_USRDLL
    -DCOLORFX_EXPORTS
    -DUSE_MESA
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libcolorfx.dylib")
    add_dependencies(colorfx tnzcore tnzbase)
endif()

message("subdir: colorfx")
message("type:" ${CMAKE_SHARED_LIBRARY_SUFFIX})
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

_find_toonz_library(EXTRA_LIBS "tnzcore;tnzbase")

message("FIND_FILE:" ${EXTRA_LIBS})

target_link_libraries(colorfx Qt5::Core Qt5::Gui ${GL_LIB} ${EXTRA_LIBS})

=== toonz/sources/image/CMakeLists.txt ===
set(HEADERS
    sgi/tiio_sgi.h
    pli/pli_io.h
    pli/tiio_pli.h
    tga/tiio_tga.h
    compatibility/inforegion.h
    compatibility/tfile_io.h
    compatibility/tnz4.h
    quantel/filequantel.h
    quantel/filequantelP.h
    quantel/tiio_quantel.h
    png/tiio_png.h
    psd/tiio_psd.h
    svg/tiio_svg.h
    tzl/tiio_tzl.h
    ../include/tnzimage.h
    mov/tiio_mov_proxy.h
    3gp/tiio_3gp_proxy.h
    ffmpeg/tiio_gif.h
    ffmpeg/tiio_webm.h
    ffmpeg/tiio_apng.h
    ffmpeg/tiio_mp4.h
    ffmpeg/tiio_ffmpeg.h
    ffmpeg/tiio_ff_mov.h
    sprite/tiio_sprite.h
    mesh/tiio_mesh.h
    exr/tinyexr_otmod.h
    exr/tiio_exr.h
    tzm/tiio_tzm.h
)

set(SOURCES
    tiio.cpp
    sgi/filesgi.cpp
    pli/pli_io.cpp
    pli/tags.cpp
    pli/tiio_pli.cpp
    tga/tiio_tga.cpp
    compatibility/inforegion.c
    compatibility/tfile_io.c
    compatibility/tnz4.c
    compatibility/tnz4_cpp.cpp
    quantel/filequantel.c
    quantel/tiio_quantel.cpp
    png/tiio_png.cpp
    psd/tiio_psd.cpp
    svg/tiio_svg.cpp
    tzl/tiio_tzl.cpp
    mov/tiio_mov_proxy.cpp
    3gp/tiio_3gp_proxy.cpp
    ffmpeg/tiio_gif.cpp
    ffmpeg/tiio_webm.cpp
    ffmpeg/tiio_apng.cpp
    ffmpeg/tiio_mp4.cpp
    ffmpeg/tiio_ffmpeg.cpp
    ffmpeg/tiio_ff_mov.cpp
    sprite/tiio_sprite.cpp
    mesh/tiio_mesh.cpp
    exr/tiio_exr.cpp
    tzm/tiio_tzm.cpp
)


# Can't build this on FreeBSD: libtiff requires internal API access.
# Probably some one get luck to fix this.
if(NOT BUILD_TARGET_BSD)
    set(HEADERS ${HEADERS}
        tif/tiio_tif.h
        tzp/tiio_plt.h
        tzp/tiio_tzp.h
        tzp/toonztags.h
    )
    set(SOURCES ${SOURCES}
        tif/tiio_tif.cpp
        tzp/tiio_plt.cpp
        tzp/tiio_tzp.cpp
        tzp/toonzrle.cpp
        tzp/avl.c
    )
endif()


if(BUILD_TARGET_WIN)
    set(HEADERS ${HEADERS}
        avi/tiio_avi.h
        mov/tiio_mov.h
        3gp/tiio_3gp.h
    )
    set(SOURCES ${SOURCES}
        avi/tiio_avi.cpp
        mov/tiio_movW.cpp
        3gp/tiio_3gpW.cpp
    )
elseif(BUILD_TARGET_APPLE)
    set(HEADERS ${HEADERS}
        mov/tiio_movM.h
        3gp/tiio_3gpM.h
    )
    set(SOURCES ${SOURCES}
        mov/tiio_movM.cpp
        3gp/tiio_3gpM.cpp
    )
elseif(BUILD_TARGET_UNIX)
    set(HEADERS ${HEADERS}
        3gp/tiio_3gp_proxy.h
        mov/tiio_mov_proxy.h
    )
    set(SOURCES ${SOURCES}
        mov/tiio_mov_proxy.cpp
        3gp/tiio_3gp_proxy.cpp
    )
endif()

if(WITH_TRANSLATION)
    add_translation(image ${HEADERS} ${SOURCES})
endif()

add_library(image SHARED ${HEADERS} ${SOURCES})
add_definitions(
    -DTNZIMAGE_DLL
    -D_USRDLL
    -DIMAGE_EXPORTS
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libimage.dylib")
    add_dependencies(image tnzcore tnzbase toonzlib)
endif()

message("subdir: image")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

include_directories(
    SYSTEM
    ${TIFF_INCLUDE_DIR}
)

if(NOT BUILD_TARGET_BSD)
    include_directories(
        ${SDKROOT}/LibJPEG/jpeg-9
    )
endif()


if(BUILD_ENV_MSVC)
    include_directories(
        SYSTEM
        ${SDKROOT}/libpng-1.6.21
    )
endif()
if(BUILD_TARGET_WIN AND PLATFORM EQUAL 32)
    include_directories(
        SYSTEM
        ${SDKROOT}/quicktime/QT73SDK/CIncludes
    )
endif()

include_directories(
    ${SDKROOT}/tinyexr
)


_find_toonz_library(TNZLIBS "tnzcore;tnzbase;toonzlib")


if(BUILD_ENV_MSVC)
    set(EXTRA_LIBS
        ${TNZLIBS}
        vfw32.lib
    )
elseif(BUILD_ENV_APPLE)
    if(PLATFORM EQUAL 32)
        find_library(CORE_SERVICES_LIB CoreServices)
        set(OSX_10_6_SDK_PATH "")
        if(NOT OSX_10_6_SDK_PATH)
            message(FATAL_ERROR "Set variable 'OSX_10_6_SDK_PATH'")
        endif()
        find_library(QD_LIB
            NAMES QD
            PATHS OSX10_6_SDK_PATH
        )
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -F ${OSX_10_6_SDK_PATH}")
    endif()
    set(EXTRA_LIBS
        Qt5::Widgets
        ${TNZLIBS}
        ${QT_LIB}
        ${CARBON_LIB}
        ${CORE_SERVICES_LIB}
        ${QD_LIB}
    )
elseif(BUILD_ENV_UNIXLIKE)
    # Generic Unix
    set(EXTRA_LIBS
        ${TNZLIBS}
    )

    if(BUILD_TARGET_WIN)
        set(EXTRA_LIBS ${EXTRA_LIBS} -lvfw32)
    endif()
endif()

target_link_libraries(image Qt5::Core Qt5::Gui Qt5::Network ${Z_LIB} ${GLUT_LIB} ${GL_LIB} ${JPEG_LIB} ${TIFF_LIB} ${PNG_LIB} ${EXTRA_LIBS})

=== toonz/sources/mousedragfilter/CMakeLists.txt ===
if(BUILD_ENV_APPLE)
    cmake_minimum_required(VERSION 2.8.11)
    project(MouseDragFilter)

    include_directories(.)
    find_library(FOUNDATION_LIBRARY NAMES Foundation)
    find_library(CG_LIBRARY NAMES CoreGraphics)
    add_library(mousedragfilter mousedragfilter.mm mousedragfilter.h)
    target_link_libraries(mousedragfilter ${CG_LIBRARY} ${FOUNDATION_LIBRARY})
endif()

=== toonz/sources/sound/CMakeLists.txt ===
set(HEADERS
    wav/tsio_wav.h
    aiff/tsio_aiff.h
    raw/tsio_raw.h
    ffmpeg/tsio_ffmpeg.h
    ../include/tnzsound.h
)

set(SOURCES
    tsio.cpp
    tsioutils.cpp
    wav/tsio_wav.cpp
    aiff/tsio_aiff.cpp
    raw/tsio_raw.cpp
    ffmpeg/tsio_ffmpeg.cpp
)

add_library(sound SHARED ${HEADERS} ${SOURCES})
add_definitions(
    -DSOUND_EXPORTS
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libsound.dylib")
    add_dependencies(sound tnzcore tnzbase toonzlib)
endif()

message("subdir: sound")
message("type:" ${CMAKE_SHARED_LIBRARY_SUFFIX})
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

_find_toonz_library(EXTRA_LIBS "tnzcore;tnzbase;toonzlib")
message("ToonzCore: " ${EXTRA_LIBS})

target_link_libraries(sound Qt5::Core ${EXTRA_LIBS})

=== toonz/sources/stdfx/CMakeLists.txt ===
set(HEADERS
    ../include/stdfx/shaderfx.h
    ../include/stdfx/shaderinterface.h
    ../include/stdfx/shadingcontext.h
    gradients.h
    hsvutil.h
    offscreengl.h
    particles.h
    particlesengine.h
    particlesfx.h
    particlesmanager.h
    perlinnoise.h
    pins.h
    stdfx.h
    texturefxP.h
    warp.h
    motionawarebasefx.h
    igs_color_blend.h
    igs_color_rgb_hls.h
    igs_color_rgb_hsv.h
    igs_density.h
    igs_fog.h
    igs_gaussian_blur.h
    igs_hls_add.h
    igs_hls_adjust.h
    igs_hls_noise.h
    igs_hls_noise_in_camera.h
    igs_hsv_add.h
    igs_hsv_adjust.h
    igs_hsv_noise.h
    igs_hsv_noise_in_camera.h
    igs_ifx_common.h
    igs_level_auto.h
    igs_level_auto_in_camera.h
    igs_levels.h
    igs_line_blur.h
    igs_math_random.h
    igs_maxmin.h
    igs_maxmin_getput.h
    igs_maxmin_lens_matrix.h
    igs_maxmin_multithread.h
    igs_maxmin_slrender.h
    igs_median_filter.h
    igs_median_filter_smooth.h
    igs_motion_blur.h
    igs_motion_wind.h
    igs_motion_wind_pixel.h
    igs_motion_wind_table.h
    igs_negate.h
    igs_os_type.h
    igs_perlin_noise.h
    igs_radial_blur.h
    igs_resource_msg_from_err.h
    igs_resource_multithread.h
    igs_resource_sleep.h
    igs_resource_thread.h
    igs_rotate_blur.h
    igs_warp.h
    ino_common.h
    iwa_adjustexposurefx.h
    iwa_directionalblurfx.h
    iwa_gradientwarpfx.h
    iwa_motionblurfx.h
    iwa_particles.h
    iwa_particlesengine.h
    iwa_particlesfx.h
    iwa_particlesmanager.h
    iwa_perspectivedistortfx.h
    iwa_spectrumfx.h
    iwa_simplexnoise.h
    iwa_noise1234.h
    iwa_fresnel.h
    iwa_pnperspectivefx.h
    iwa_soapbubblefx.h
    iwa_bokehfx.h
    iwa_timecodefx.h
    iwa_bokehreffx.h
    iwa_textfx.h
    iwa_corridorgradientfx.h
    iwa_spingradientfx.h
    iwa_lineargradientfx.h
    iwa_glarefx.h
    iwa_fractalnoisefx.h
    iwa_rainbow_intensity.h
    iwa_rainbowfx.h
    iwa_bokeh_advancedfx.h
    iwa_bokeh_util.h
    globalcontrollablefx.h
    iwa_floorbumpfx.h
    iwa_tangentflowfx.h
    iwa_flowblurfx.h
    iwa_flowpaintbrushfx.h
    iwa_motionflowfx.h
)

if(OpenCV_FOUND)
    list(APPEND HEADERS iwa_bloomfx.h)
endif()

set(SOURCES
    adjustlevelsfx.cpp
    artcontourfx.cpp
    backlitfx.cpp
    blendtzfx.cpp
    blurfx.cpp
    bodyhighlightfx.cpp
    bright_contfx.cpp
    calligraphicfx.cpp
    changecolorfx.cpp
    channelmixerfx.cpp
    cloudsfx.cpp
    colorembossfx.cpp
    cornerpinfx.cpp
    despecklefx.cpp
    diamondgradientfx.cpp
    dissolvefx.cpp
    embossfx.cpp
    erodilatefx.cpp
    externalpalettefx.cpp
    fourpointsgradientfx.cpp
    freedistortfx.cpp
    gammafx.cpp
    glowfx.cpp
    gradients.cpp
    hsvkeyfx.cpp
    hsvscalefx.cpp
    hsvutil.cpp
    kaleido.cpp
    linearwavefx.cpp
    localblurfx.cpp
    localtransparencyfx.cpp
    mosaicfx.cpp
    motionblurfx.cpp
    multitonefx.cpp
    noisefx.cpp
    nothingfx.cpp
    palettefilterfx.cpp
    particles.cpp
    particlesengine.cpp
    particlesfx.cpp
    particlesmanager.cpp
    perlinnoise.cpp
    perlinnoisefx.cpp
    pins.cpp
    posterizefx.cpp
    premultiplyfx.cpp
    radialblurfx.cpp
    randomwavefx.cpp
    raylitfx.cpp
    rgbkeyfx.cpp
    rgbmcutfx.cpp
    rgbmfadefx.cpp
    rgbmscalefx.cpp
    ripplefx.cpp
    rotationalblurfx.cpp
    saltpeppernoisefx.cpp
    shaderfx.cpp
    shaderinterface.cpp
    shadingcontext.cpp
    sharpenfx.cpp
    solarizefx.cpp
    squaregradientfx.cpp
    stdfx.cpp
    targetspotfx.cpp
    texturefx.cpp
    tilefx.cpp
    tonecurvefx.cpp
    unmultiplyfx.cpp
    warp.cpp
    warpfx.cpp
    igs_attenuation_distribution.cpp
    igs_color_blend.cpp
    igs_color_rgb_hls.cpp
    igs_color_rgb_hsv.cpp
    igs_density.cpp
    igs_fog.cpp
    igs_gauss_distribution.cpp
    igs_gaussian_blur.cpp
    igs_hls_add.cpp
    igs_hls_adjust.cpp
    igs_hls_noise.cpp
    igs_hls_noise_in_camera.cpp
    igs_hsv_add.cpp
    igs_hsv_adjust.cpp
    igs_hsv_noise.cpp
    igs_hsv_noise_in_camera.cpp
    igs_level_auto.cpp
    igs_level_auto_in_camera.cpp
    igs_levels.cpp
    igs_line_blur.cpp
    igs_math_random.cpp
    igs_maxmin.cpp
    igs_maxmin_lens_matrix.cpp
    igs_maxmin_slrender.cpp
    igs_median_filter.cpp
    igs_median_filter_smooth.cpp
    igs_motion_blur.cpp
    igs_motion_wind.cpp
    igs_motion_wind_pixel.cpp
    igs_motion_wind_table.cpp
    igs_negate.cpp
    igs_perlin_noise.cpp
    igs_radial_blur.cpp
    igs_resource_msg_from_err.cpp
    igs_resource_multithread.cpp
    igs_resource_sleep.cpp
    igs_resource_thread.cpp
    igs_rotate_blur.cpp
    igs_warp_hori.cpp
    igs_warp_vert.cpp
    ino_blend_add.cpp
    ino_blend_color_burn.cpp
    ino_blend_color_dodge.cpp
    ino_blend_cross_dissolve.cpp
    ino_blend_darken.cpp
    ino_blend_darker_color.cpp
    ino_blend_divide.cpp
    ino_blend_hard_light.cpp
    ino_blend_hard_mix.cpp
    ino_blend_lighten.cpp
    ino_blend_lighter_color.cpp
    ino_blend_linear_burn.cpp
    ino_blend_linear_dodge.cpp
    ino_blend_linear_light.cpp
    ino_blend_multiply.cpp
    ino_blend_over.cpp
    ino_blend_overlay.cpp
    ino_blend_pin_light.cpp
    ino_blend_screen.cpp
    ino_blend_soft_light.cpp
    ino_blend_subtract.cpp
    ino_blend_vivid_light.cpp
    ino_blur.cpp
    ino_channel_selector.cpp
    ino_common.cpp
    ino_density.cpp
    ino_fog.cpp
    ino_hls_add.cpp
    ino_hls_adjust.cpp
    ino_hls_noise.cpp
    ino_hsv_add.cpp
    ino_hsv_adjust.cpp
    ino_hsv_noise.cpp
    ino_level_auto.cpp
    ino_level_master.cpp
    ino_level_rgba.cpp
    ino_line_blur.cpp
    ino_maxmin.cpp
    ino_median.cpp
    ino_median_filter.cpp
    ino_motion_blur.cpp
    ino_motion_wind.cpp
    ino_negate.cpp
    ino_pn_clouds.cpp
    ino_radial_blur.cpp
    ino_spin_blur.cpp
    ino_warp_hv.cpp
    iwa_adjustexposurefx.cpp
    iwa_directionalblurfx.cpp
    iwa_gradientwarpfx.cpp
    iwa_motionblurfx.cpp
    iwa_particles.cpp
    iwa_particlesengine.cpp
    iwa_particlesfx.cpp
    iwa_particlesmanager.cpp
    iwa_perspectivedistortfx.cpp
    iwa_spectrumfx.cpp
    iwa_tilefx.cpp
    iwa_simplexnoise.cpp
    iwa_noise1234.cpp
    iwa_pnperspectivefx.cpp
    iwa_soapbubblefx.cpp
    ${SDKROOT}/kiss_fft130/kiss_fft.c
    ${SDKROOT}/kiss_fft130/tools/kiss_fftnd.c
    iwa_bokehfx.cpp
    iwa_timecodefx.cpp
    iwa_bokehreffx.cpp
    iwa_barreldistortfx.cpp
    iwa_textfx.cpp
    iwa_corridorgradientfx.cpp
    iwa_spingradientfx.cpp
    iwa_lineargradientfx.cpp
    iwa_glarefx.cpp
    iwa_fractalnoisefx.cpp
    iwa_rainbowfx.cpp
    iwa_bokeh_advancedfx.cpp
    iwa_bokeh_util.cpp
    iwa_floorbumpfx.cpp
    iwa_tangentflowfx.cpp
    iwa_flowblurfx.cpp
    iwa_flowpaintbrushfx.cpp
    iwa_motionflowfx.cpp
)

if(OpenCV_FOUND)
    list(APPEND SOURCES iwa_bloomfx.cpp)
endif()

set(OBJCSOURCES
)

add_library(tnzstdfx SHARED ${HEADERS} ${SOURCES} ${OBJCSOURCES})
add_definitions(
    -D_USRDLL
    -DTNZSTDFX_EXPORTS
)

if(BUILD_ENV_APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-install_name,@executable_path/libtnzstdfx.dylib")
    add_dependencies(tnzstdfx tnzcore tnzbase toonzlib)
endif()

message("subdir: tnzstdfx")
message("Bin: " ${CMAKE_CURRENT_BINARY_DIR})

if(GLEW_FOUND)
    include_directories(
        SYSTEM
        ${GLEW_INCLUDE_DIRS}
    )
else()
    include_directories(
        SYSTEM
        ${SDKROOT}/glew/glew-1.9.0/include
    )
endif()

include_directories(
    ${SDKROOT}/kiss_fft130
)

_find_toonz_library(TNZLIBS "tnzcore;tnzbase;toonzlib")

target_link_libraries(tnzstdfx Qt5::Core Qt5::Gui Qt5::OpenGL ${GL_LIB} ${GLEW_LIB} ${TNZLIBS} ${PTHREAD_LIBRARY})

if(OpenCV_FOUND)
    target_link_libraries(tnzstdfx ${OpenCV_LIBS})
endif()

=== toonz/sources/t32bitsrv/CMakeLists.txt ===
add_executable(t32bitsrv
    main.cpp
    t323gpmsg.cpp
    t323gpmsg.h
    t32fontmsg.cpp
    t32fontmsg.h
    t32movmsg.cpp
    t32movmsg.h
)

if(BUILD_TARGET_WIN)
    include_directories(
        SYSTEM
        ${SDKROOT}/quicktime/QT73SDK/CIncludes
    )
endif()

target_link_libraries(t32bitsrv
    Qt5::Core
    Qt5::Network
    tnzcore
    image
)

if(BUILD_ENV_APPLE AND PLATFORM EQUAL 32)
    get_target_property(bin t32bitsrv LOCATION)
    get_filename_component(bindir ${bin} DIRECTORY)

    get_target_property(loc tnzcore LOCATION)
    add_custom_command(TARGET t32bitsrv POST_BUILD COMMAND cp ${loc} ${bindir})
    get_target_property(loc image LOCATION)
    add_custom_command(TARGET t32bitsrv POST_BUILD COMMAND cp ${loc} ${bindir})
    get_target_property(loc tnzbase LOCATION)
    add_custom_command(TARGET t32bitsrv POST_BUILD COMMAND cp ${loc} ${bindir})

    add_custom_command(TARGET t32bitsrv
        POST_BUILD COMMAND
        ${CMAKE_INSTALL_NAME_TOOL} -add_rpath @executable_path/. ${bin}
    )
endif()

=== debian/changelog ===
opentoonz-dmo (1.7.1.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 10 Apr 2025 08:12:24 +0200

opentoonz-dmo (1.7.1.0-dmo1+b1) unstable; urgency=medium

  * Build with opencv 4.10.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 15 Feb 2025 09:14:12 +0100

opentoonz-dmo (1.7.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 14 Jan 2025 11:19:58 +0100

opentoonz-dmo (1.7.1-dmo3+b1) unstable; urgency=medium

  * Rebuild for PAC/BTI support; no source changes.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 01 Nov 2024 16:32:49 +0100

opentoonz-dmo (1.7.1-dmo3) unstable; urgency=medium

  * Rebuild for time_t

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 16 Mar 2024 18:48:15 +0100

opentoonz-dmo (1.7.1-dmo2) unstable; urgency=medium

  * Build with libsuperlu6

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 31 Aug 2023 08:25:50 +0200

=== debian/control ===
Source: opentoonz-dmo
Section: graphics
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://opentoonz.github.io/e/index.html
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13), dh-sequence-scour [all], cmake,
 qtbase5-dev, libqt5svg5-dev, qtscript5-dev, qttools5-dev, qttools5-dev,
 libqt5opengl5-dev, qtmultimedia5-dev, libsuperlu-dev (>= 6~), liblz4-dev,
 libusb-1.0-0-dev, liblzo2-dev, libpng-dev, libjpeg-dev, libturbojpeg0-dev,
 freeglut3-dev (>= 3.4.0~), libsdl2-dev, libfreetype-dev, libopencv-dev,
 libmypaint-dev (>= 1:1.6.1~), libglew-dev (>= 2.2.0~), libqt5serialport5-dev,
 patchelf, ninja-build, qtbase5-dev, libboost-dev

Package: opentoonz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, opentoonz-data (= ${source:Version}),
Description: full-featured 2D animation creation software
 This is software for producing a 2D animation.
 .
 It is based on the software "Toonz", which was developed by Digital Video
 S.p.A. in Italy, customized by Studio Ghibli, and has been used for
 creating its works for many years.
 Dwango launches this OpenToonz project, in cooperation with Digital Video
 and Studio Ghibli.

Package: opentoonz-data
Architecture: all
Depends: ${misc:Depends},
Description: Open-source full-featured 2D animation creation software (data package)
 This is software for producing a 2D animation.
 .
 It is based on the software "Toonz", which was developed by Digital Video
 S.p.A. in Italy, customized by Studio Ghibli, and has been used for
 creating its works for many years.
 Dwango launches this OpenToonz project, in cooperation with Digital Video
 and Studio Ghibli.
 .
 (This package contains the data files).

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(findstring parallel=,$(DEB_BUILD_OPTIONS)))
	NCPUS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
	ifeq ($(NCPUS),-1)
		NCPUS:=1
	endif
	ifeq ($(NCPUS),0)
		NCPUS:=1
	endif
endif

export DEB_CFLAGS_MAINT_APPEND = -fPIC

ifeq ($(origin CC),default)
	CC := $(DEB_HOST_GNU_TYPE)-gcc
endif
export CC

ifeq ($(origin CXX),default)
	CXX := $(DEB_HOST_GNU_TYPE)-g++
endif
export CXX

%:
	dh $@ -Dtoonz/sources -Bbuild -Scmake+ninja

override_dh_auto_configure:
	cd thirdparty/tiff-4.0.3 && \
	./configure \
	--with-pic \
	--disable-jbig 

	$(MAKE) -C thirdparty/tiff-4.0.3 -j $(NCPUS)

	dh_auto_configure  -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_BUILD_WITH_INSTALL_RPATH=FALSE \
	-DCMAKE_SKIP_RPATH-ADVANCED=FALSE \
	-DWITH_TRANSLATION=OFF \
	-Wno-dev

#	exit 1

# Doesn't link against system libtiff
#	-DTIFF_LIBRARY:FILEPATH=/usr/lib/$(DEB_HOST_MULTIARCH)/libtiff.so

execute_after_dh_auto_install:
	patchelf --remove-rpath debian/tmp/usr/lib/opentoonz/*.so
	patchelf --remove-rpath debian/tmp/usr/bin/t*
	patchelf --remove-rpath debian/tmp/usr/bin/l*
	patchelf --remove-rpath debian/tmp/usr/bin/OpenToonz

override_dh_auto_clean:
	[ ! -f thirdparty/tiff-4.0.3/Makefile ] || $(MAKE) -C thirdparty/tiff-4.0.3 distclean

	dh_auto_clean

override_dh_clean:

#	-rm -rf thirdparty/boost
#	-rm -rf thirdparty/glew
#	-rm -rf thirdparty/glut
#	-rm -rf thirdparty/LibJPEG
#	-rm -rf thirdparty/libmypaint
#	-rm -rf thirdparty/libpng-*
#	-rm -rf thirdparty/libusb
#	-rm -rf thirdparty/Lz4
#	-rm -rf thirdparty/openblas
#	-rm -rf thirdparty/quicktime
#	-rm -rf thirdparty/superlu
#	-rm -rf thirdparty/zlib-*

#	find -name *.exe -delete

	dh_clean

# Don't delete these directories
# thirdparty/kiss_fft130
# thirdparty/lzo
# thirdparty/tiff-4.0.3

override_dh_auto_test:
